#include <stdio.h>
#include "externs.h"

static char dummy_trk_buf[ BYTES_PER_SECTOR * SECTORS_PER_TRACK ];

/*
    Try to read Track 0, Side 0, if that works, check
    Track 0, Side 1 (incase it's single sided...)

    The idea is:

        if( disk_is_formated( 'A' ) )
            printf("Drive A has a formated disk...");
        else
            printf("Drive A is not formated....");
*/

disk_is_formated( drive )
char drive;
{
    if( read_sectors( drive, 0, 0, dummy_trk_buf ) )    /* side 0 */
        return 0;
    else
        if( read_sectors( drive, 0, 1, dummy_trk_buf ) ) /* side 1 */
            return 0;
        else
            return 1;
}

compare_disk( drive )
int drive;
{
register int t, h;

    for( t = 0 ; t < TRACKS_PER_DISK ; t++ )
        for( h = 0 ; h < SIDES_PER_DISK ; h++ )
            if( read_sectors( drive, t, h, dummy_trk_buf ) != 0 )
                return -1; /* can't read... */
            else 
                if( comp_sectors( t, h ) )
                    return -1;
        
    return 0;
}

comp_sectors( t, h )
int t, h;
{
    return memcmp( dummy_trk_buf,                 /* ADDRESS 1 */
                   &(track[t]->head[h].data[0]),  /* ADRESS 2 */
                   BYTES_PER_SECTOR * SECTORS_PER_TRACK ); /* Size in BYTES */
#if	0
   /* If your compiler does not have this unix function... then do this: */
register int x;
    
    for( x = 0 ; x < (BYTES_PER_SECTOR * SECTORS_PER_TRACK) ; x++ )
        if( track[t]->head[h].data[x] != dummy_trk_buf[x] )
            return 1;
    
    return 0;
#endif
    ; /* must be here... You Must have a statement after a endif... */
}
