#define    MAIN_MODULE
#include <stdio.h>
#include "externs.h"

#define    WhatDrive    (Drive_A_Valid ? 'A' : 'B')

main(argc,argv)
int argc;
char *argv[];
{
int    x;

    /* set defaults... */
    ignore_formated_disks = FALSE;
    VerifyDisk = TRUE;
    Drive_A_Valid = NO;
    Drive_B_Valid = NO;

    cls();

    for( x = 1 ; x < argc ; x++ )
        if( argv[x][0] == '-' )
            switch( toupper(argv[x][1]) ){
                case 'I':
                    ignore_formated_disks = TRUE;
                    break;
                case 'V':
                    VerifyDisk = FALSE;
                    break;
                case 'A':
                    Drive_A_Valid = YES;
                    break;
                case 'B':
                    Drive_B_Valid = YES;
                    break;
                case 'H':
                case '?':
                    help();
                    break;
            }
        else 
            help();

    if( !(Drive_A_Valid || Drive_B_Valid) ){
        go(0,0); printf("You did not tell me what drive to use!");
        help();
    }

    go(12,25); printf("Insert MASTER DISK in Drive %c", WhatDrive );
    press_a_key(13);
    go(12,25); printf("                               ");

    go(12,30); printf("Reading Master Disk.");
    read_disk( WhatDrive );
    go(12,30); printf("                    ");

    if( Drive_A_Valid && Drive_B_Valid ){
        go(8,23); printf("I will swap between Drive A and B.");
    } else {
        go(8,28); printf("I will only use Drive %c", WhatDrive );
    }
    go(12,10); 
    printf("Press 'Q' during formatting to stop at end of current disk.");

    TotalDone = 0;

    flush_kbd();

    /* loop copying to drives as appropriate */
    for(;;){
        feed_me();
        wait_and_beep();
        go(16, 31); printf("                          ");

        show_total();
    
        if( Drive_A_Valid )
            do_a_disk( 'A' );
        
        flush_kbd();
        show_total();

        if( Drive_B_Valid )
            do_a_disk( 'B' );

        flush_kbd();
        show_total();
    }
}

/* quick and dirty functions... */

press_a_key(row)
int row;
{
    go(row,30);
    printf("...Press any key...              ");
    wait_and_beep();
    go(row,30);
    printf("                      ");
}

show_total()
{
    go(13, 29); printf("Total Disks So far %3d", TotalDone );
}

feed_me()
{
    go(16, 31); printf("Insert Next Disks......." );
}


/* 
    This waits for a key, and beeps every second.
    Why? Well, I walk away from the computer, this gently
    remindes me to do something...
 */

wait_and_beep()
{
    flush_kbd();

    timer_ran_out( -1 );    /* Initialize the Timer... */
    do {
        if( timer_ran_out(0) )
            beep();
    } while( !poll() );
    flush_kbd();

}


