#include <stdio.h>
#include "externs.h"

/*
 *  All of the read/write/verify functions have the same register
 *  parameters... only AH changes... So this one finishes up the
 *  functions...
 */

static int finish_it( AX_VAL, drive, track, head, buffer )
int AX_VAL, drive, track, head;
char *buffer;
{
int    tries;

    go( 21, 20 );
    printf("Drive %c, Track %2d, Head %d, Function 0x%04x",
        drive, track, head, AX_VAL );

    input_regs.AX = AX_VAL;
    input_regs.ES = _seg_part( buffer );
    input_regs.BX = _off_part( buffer );
    input_regs.CX = (track<<8) | 1;
    input_regs.DX = (head<<8)  | (drive-'A');

#ifdef    TESTING
    getachr();
    FLAGS = 0;
#else
    for( tries = 0, FLAGS = -1 ; (tries < MAX_TRIES) && CARRY_SET ; tries++ )
        FLAGS = sysint( 0x13, &input_regs, &output_regs);
#endif

    if( CARRY_SET )
        return 1;
    else
        return 0;
}

read_sectors( drive, track, head, buffer )
int drive, track, head;
char *buffer;
{
    return finish_it( 0x0209, drive, track, head, buffer );
}

verify_sectors( drive, track, head, buffer )
int drive, track, head;
char *buffer;
{
    return finish_it( 0x0409, drive, track, head, buffer );
}

write_sectors( drive, track, head, buffer )
int drive, track, head;
char *buffer;
{
    return finish_it( 0x0309, drive, track, head, buffer );
}


